// Code generated by Frodo from scores/score_service.go - DO NOT EDIT
//
//   https://github.com/monadicstack/frodo
//
package scores

import (
	"net/http"

	"github.com/monadicstack/frodo/example/multiservice/scores"
	"github.com/monadicstack/frodo/rpc"
	"github.com/monadicstack/respond"
)

// NewScoreServiceGateway accepts your "real" ScoreService instance (the thing that really does the work), and
// exposes it to other services/clients over RPC. The rpc.Gateway it returns implements http.Handler, so you
// can pass it to any standard library HTTP server of your choice.
//
//	// How to fire up your service for RPC and/or your REST API
//	service := scores.ScoreService{ /* set up to your liking */ }
//	gateway := scores.NewScoreServiceGateway(service)
//	http.ListenAndServe(":8080", gateway)
//
// The default instance works well enough, but you can supply additional options such as WithMiddleware() which
// accepts any negroni-compatible middleware handlers.
func NewScoreServiceGateway(service scores.ScoreService, options ...rpc.GatewayOption) rpc.Gateway {
	gw := rpc.NewGateway(options...)
	gw.Name = "ScoreService"
	gw.PathPrefix = "/v2"

	gw.Register(rpc.Endpoint{
		Method:      "GET",
		Path:        "/game/:GameID/highscore",
		ServiceName: "ScoreService",
		Name:        "HighScoresForGame",
		Handler: func(w http.ResponseWriter, req *http.Request) {
			response := respond.To(w, req)

			serviceRequest := scores.HighScoresForGameRequest{}
			if err := gw.Binder.Bind(req, &serviceRequest); err != nil {
				response.Fail(err)
				return
			}

			serviceResponse, err := service.HighScoresForGame(req.Context(), &serviceRequest)
			response.Reply(200, serviceResponse, err)
		},
	})

	gw.Register(rpc.Endpoint{
		Method:      "POST",
		Path:        "/game/:GameID/highscore",
		ServiceName: "ScoreService",
		Name:        "NewHighScore",
		Handler: func(w http.ResponseWriter, req *http.Request) {
			response := respond.To(w, req)

			serviceRequest := scores.NewHighScoreRequest{}
			if err := gw.Binder.Bind(req, &serviceRequest); err != nil {
				response.Fail(err)
				return
			}

			serviceResponse, err := service.NewHighScore(req.Context(), &serviceRequest)
			response.Reply(201, serviceResponse, err)
		},
	})

	return gw
}
